//*****************************************************************************
// File Name            : vout.c
//-----------------------------------------------------------------------------
// Function             : mb_mem_ap vout
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2017/4/23
//*****************************************************************************
#include <stdio.h>
#include "platform.h"
#include "xparameters.h"
#include "xvtc.h"
#include "xaxivdma.h"
#include "xil_cache.h"
#define GPIO_EXAMPLE_DEVICE_ID XPAR_GPIO_0_DEVICE_ID
#define DMA_DEVICE_ID XPAR_AXIVDMA_0_DEVICE_ID
#define XVTC_DEVICE_ID XPAR_VTC_0_DEVICE_ID
XVtc VtcInst;
XAxiVdma AxiVdma;
int main()
{
int i,v,h1;
int Status;
volatile unsigned char *ddr_ptr;
//
XVtc_Config *Config_vtc;
XAxiVdma_Config *Config_Vdma;
init_platform();
print("Hello World\n\r");
Xil_DCacheDisable();//LbV
//vtcݒ
Config_vtc = XVtc_LookupConfig(XVTC_DEVICE_ID);
Status = XVtc_CfgInitialize(&VtcInst,Config_vtc, Config_vtc->BaseAddress);
if (Status != (XST_SUCCESS)) {
  return (XST_FAILURE);
}
XVtc_Enable(&VtcInst); //vtc start
//dmaݒ
Config_Vdma = XAxiVdma_LookupConfig(DMA_DEVICE_ID);
if (!Config_Vdma){
  return XST_FAILURE;
}
Status=XAxiVdma_CfgInitialize(&AxiVdma,Config_Vdma, Config_Vdma->BaseAddress);
if (Status != XST_SUCCESS) {
  return XST_FAILURE;
}
//dmaWX^ݒ
XAxiVdma_WriteReg(XPAR_AXI_VDMA_0_BASEADDR,0x0, 0x4); //reset
XAxiVdma_WriteReg(XPAR_AXI_VDMA_0_BASEADDR,0x0, 0x8); //gen-lock
XAxiVdma_WriteReg(XPAR_AXI_VDMA_0_BASEADDR,0x5C, 0x88000000);//start adr
XAxiVdma_WriteReg(XPAR_AXI_VDMA_0_BASEADDR,0x54, 1280*3);//h size
XAxiVdma_WriteReg(XPAR_AXI_VDMA_0_BASEADDR,0x58, 0x01001000);//
XAxiVdma_WriteReg(XPAR_AXI_VDMA_0_BASEADDR,0x0, 0x83);//enablr
XAxiVdma_WriteReg(XPAR_AXI_VDMA_0_BASEADDR,0x50, 720);//v size,start dma
Status = XAxiVdma_ReadReg(XPAR_AXI_VDMA_0_BASEADDR, 0x24);
//摜f[^
xil_printf("dma status:%x \n\r",Status);
while(1){
  for(i=0;i<4;i++){
    for(v=0;v<720;v++){ //JEg
      for(h1=0;h1<1280;h1++){ //JEg
        ddr_ptr = (unsigned char *) 0x88000000+(v*0x1000)+h1*3;
        if((i==0)||(i==3))
          *ddr_ptr = 0xff; //
        else
          *ddr_ptr = 0x0;
        ddr_ptr++;
        if((i==1)||(i==3))
          *ddr_ptr = 0xff;//
        else
          *ddr_ptr = 0x0;
        ddr_ptr++;
        if((i==2)||(i==3))
          *ddr_ptr = 0xff;//
        else
          *ddr_ptr = 0x0;
      }
    }
  }
}
cleanup_platform();
return 0;
}
